package com.test.moible.chinaMobile;

import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.PrintWriter;
import java.util.Date;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.test.moible.utils.HttpsClientUtil;

/**
 * 获取移动的验证码页面信息
 * @author wudy
 *
 */
public class ChinaMobileLoginImageServlet extends HttpServlet {
  
  private final Logger logger = LoggerFactory.getLogger(ChinaMobileLoginImageServlet.class);

  /**
   * 
   */
  private static final long serialVersionUID = 1L;
  
  
  @Override
  protected void doPost(HttpServletRequest req, HttpServletResponse resp)
      throws ServletException, IOException {
    DefaultHttpClient httpClient = new DefaultHttpClient();
    // 中国移动
    logger.info("获取中国移动的验证码信息");
    PrintWriter printWriter = resp.getWriter();
    FileOutputStream out = null;//文件输出流
    String fileName = null;//保存时候使用的文件名
    InputStream input = null;//文件的输入流对象
    try {
        HttpsClientUtil.SecurityProcess(httpClient);
        String url = "https://zj.ac.10086.cn/ImgDisp?r=" + new Date().getTime();
        HttpGet httppost = new HttpGet(url);
  
        HttpResponse response = httpClient.execute(httppost);
        HttpEntity entity = response.getEntity();
         input = entity.getContent();
  
        fileName = System.currentTimeMillis() + ".png";
        out = new FileOutputStream(req.getSession().getServletContext().getRealPath("/upload") + "/" + fileName);
  
        int i;
        while ((i = input.read()) != -1) {
          out.write(i);
        }
        out.flush();
        printWriter.write("upload/" + fileName);
        req.getSession().setAttribute("httpClient", httpClient);
        logger.info("中国移动的验证码已经获取");
    } catch (Exception e) {
        logger.error("获取中国移动的登陆验证码异常:" + e.toString());
    }finally{
      if(out!=null){
        try {
          input.close();
          out.close();//关闭输出流
        } catch (IOException e) {
         logger.error("获取中国移动的验证码，输出流关闭异常，异常信息:"+e.toString());
        }
      }
    }
    logger.info("获取中国移动的验证码信息结束");
  }
  
  
  @Override
  protected void doGet(HttpServletRequest req, HttpServletResponse resp)
      throws ServletException, IOException {
      this.doPost(req, resp);
  }

}
