package com.test.moible.chinaMobile;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.http.HttpEntity;
import org.apache.http.NameValuePair;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.util.EntityUtils;
import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;
import org.jsoup.select.Elements;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.test.moible.utils.CallDetailDataUtils;
import com.test.moible.utils.HttpsClientUtil;

/**
 * 获取移动的详单和个人信息查询页面
 * @author wudy
 *
 */
public class ChinaMobileQueryDetailServlet extends HttpServlet {
  
  private final Logger logger = LoggerFactory.getLogger(ChinaMobileQueryDetailServlet.class);

  /**
   * 
   */
  private static final long serialVersionUID = 1L;
  
  
  @Override
  protected void doPost(HttpServletRequest req, HttpServletResponse resp)
      throws ServletException, IOException {
    
    DefaultHttpClient httpClient = (DefaultHttpClient) req.getSession().getAttribute("httpClient");
    String validateCode = req.getParameter("validateCode");
    
    try {
           
          List<NameValuePair> paramsList = new ArrayList<NameValuePair>();
          paramsList.add(new BasicNameValuePair("bid", "BC5CC0A69BC10482E044001635842132"));
          paramsList.add(new BasicNameValuePair("validateCode", validateCode));

          HttpPost httppost = new HttpPost("http://service.zj.10086.cn/yw/detail/secondPassCheck.do");
          httppost.setEntity(new UrlEncodedFormEntity(paramsList));
          CloseableHttpResponse httpResponse = httpClient.execute(httppost);
          EntityUtils.toString(httpResponse.getEntity());
          if (httpResponse.getStatusLine().getStatusCode() == 200) {//二次动态码校验通过
            new Thread(new Runnable() {
              public void run() {
                /** 获取通话详情记录 **/
                String[] mouthArray = CallDetailDataUtils.fetchMouthArrayForChinaMobile();//需要处理的最近5个月话单信息的月份信息
               try{
                       for (String mouthStr : mouthArray) {//开始爬取每月的花费详单记录
                         HttpGet httpGet = null;//HttpGet请求对象
                         CloseableHttpResponse responseEntity = null;//请求响应对象
                         HttpEntity httpEntity = null;//请求实体
                         String resultStr = null;//请求实体对应的结果字符串
                         try {
                             httpGet = new HttpGet( "http://service.zj.10086.cn/yw/detail/queryHisDetailBill.do?bid=&menuId=13009&listtype=1&month=" + mouthStr);
                             responseEntity = httpClient.execute(httpGet);
                             httpEntity = responseEntity.getEntity();
                             resultStr = EntityUtils.toString(httpEntity);
                             logger.info("用户的{}详单信息是{}",mouthStr,resultStr);
                           Thread.sleep(3000);// 每次请求完成后停止3s,防止请求过度
                         } catch (InterruptedException e) {
                           logger.error("获取中国移动话单信息出错，信息如下："+e.toString());
                         } 
                       }
               }catch(Exception e){
                 e.printStackTrace();
               } 
                
                try {
                  // 二次密码信息校验
                  List<NameValuePair> params2 = new ArrayList<NameValuePair>();
                  params2.add(new BasicNameValuePair("validateCode", validateCode));
                  params2.add(new BasicNameValuePair("listtype", ""));
                  params2.add(new BasicNameValuePair("jumpUrl","/yw/info/queryCustomerInfo.do?menuId=13099&bid="));
                  String tempStr = HttpsClientUtil.HttpPost(httpClient, "http://service.zj.10086.cn/validatecode/submitValidateCode.do", params2);
                  // 开始请求用户信息
                  StringBuffer sb = new StringBuffer("<html><head><title></title></head><body>");
                  sb.append(tempStr);
                  sb.append("</body></html>");
                  Document doc = Jsoup.parse(sb.toString());
                  Elements elements = doc.getElementsByAttributeValue("type", "hidden");
                  List<NameValuePair> params3 = new ArrayList<NameValuePair>();
                  for (Element el : elements) {
                    params3.add(new BasicNameValuePair(el.attr("name"), el.val()));
                  }
                  //查询个人信息请求
                  HttpGet httpGet = new HttpGet("http://service.zj.10086.cn/yw/info/queryCustomerInfo.do?menuId=13099&bid=BD399F39E69148CFE044001635842131");
                  CloseableHttpResponse responseEntity = httpClient.execute(httpGet);
                  HttpEntity httpEntity = responseEntity.getEntity();
                  String resultStr = EntityUtils.toString(httpEntity);
                  //解析返回的数据
                  logger.info("用户的个人信息如下{}",resultStr);
                } catch (IOException e) {
                  logger.error("获取中国移动个人信息详情出错，异常如下:"+e.toString());
                }
              }//Run方法到此结束
            }).start();//线程处理到此结束
          } else {
            logger.error("二次验证码验证请求异常，手机号:");
          }
        } catch (Exception e) {
          logger.error("中国移动的二次校验系统异常，异常信息:"+e.toString());
          req.getRequestDispatcher("/error.jsp").forward(req, resp);
        }
    
      req.getRequestDispatcher("/success.jsp").forward(req, resp);
  }
  
  
  @Override
  protected void doGet(HttpServletRequest req, HttpServletResponse resp)
      throws ServletException, IOException {
      this.doPost(req, resp);
  }

}
