package com.test.moible.chinaMobile;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.ParseException;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.util.EntityUtils;
import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;
import org.jsoup.select.Elements;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.test.moible.utils.CallDetailDataUtils;
import com.test.moible.utils.HttpsClientUtil;


/**
 * 获取移动的二次验证码信息的同时获取月汇总账单信息
 * @author wudy
 *
 */
public class ChinaMobileSecondPassCheckServlet extends HttpServlet {
  
  private final Logger logger = LoggerFactory.getLogger(ChinaMobileSecondPassCheckServlet.class);

  /**
   * 
   */
  private static final long serialVersionUID = 1L;
  
  
  @Override
  protected void doPost(HttpServletRequest req, HttpServletResponse resp)
      throws ServletException, IOException {
    
    logger.info("开始获取中国移动的二次校验动态码");
    DefaultHttpClient httpClient = (DefaultHttpClient) req.getSession().getAttribute("httpClient");
    // 中国移动

    String phoneNo = req.getParameter("phoneNo");
    String password = req.getParameter("password");
    String validateCode = req.getParameter("validateCode");
    try {

      List<NameValuePair> params = new ArrayList<NameValuePair>();
      params.add(new BasicNameValuePair("failurl", "https://zj.ac.10086.cn/login"));
      params.add(new BasicNameValuePair("continue","http://service.zj.10086.cn/yw/detail/queryHisDetailBill.do?bid=&menuId=13009"));
      // params.add(new BasicNameValuePair("continue", "/my/login/loginSuccess.do"));
      params.add(new BasicNameValuePair("style", "1"));
      params.add(new BasicNameValuePair("pwdType", "2"));
      params.add(new BasicNameValuePair("mima", "fuwumima"));
      params.add(new BasicNameValuePair("SMSpwdType", "0"));
      params.add(new BasicNameValuePair("service", "my"));
      params.add(new BasicNameValuePair("billId", phoneNo));
      params.add(new BasicNameValuePair("passwd", password));
      params.add(new BasicNameValuePair("validCode", validateCode));

      //登录验证
      HttpResponse httpResponse = HttpsClientUtil.HttpPostForHttpResponse(httpClient, "https://zj.ac.10086.cn/loginbox", params);
      if (httpResponse.getStatusLine().getStatusCode() == 200) {//登录状态成功
        String resultStr = EntityUtils.toString(httpResponse.getEntity());

        StringBuffer sb = new StringBuffer("<html><head><title></title></head><body>");
        sb.append(resultStr);
        sb.append("</body></html>");
        Document doc = Jsoup.parse(sb.toString());
        Elements elements = doc.getElementsByAttributeValue("type", "hidden");
        params = new ArrayList<NameValuePair>();
        for (Element el : elements) {
          params.add(new BasicNameValuePair(el.attr("name"), el.val()));
        }
        //SSO验证
        resultStr = HttpsClientUtil.HttpPost(httpClient, "http://www.zj.10086.cn/my/sso", params);

        sb = new StringBuffer("<html><head><title></title></head><body>");
        sb.append(resultStr);
        sb.append("</body></html>");
        doc = Jsoup.parse(sb.toString());
        elements = doc.getElementsByAttributeValue("type", "hidden");
        params = new ArrayList<NameValuePair>();
        for (Element el : elements) {
          params.add(new BasicNameValuePair(el.attr("name"), el.val()));
        }
        //UnifiedLoginClientServlet请求验证
        resultStr = HttpsClientUtil.HttpPost(httpClient,"http://service.zj.10086.cn/UnifiedLoginClientServlet", params);
       
        new Thread(new Runnable(){//抓取中国移动的每月账单汇总信息
          public void run() {
            logger.info("开始获取用户的月度汇总账单细信息，手机号码：{}",phoneNo);
            List<NameValuePair> detailUrlParam = new ArrayList<NameValuePair>();
            HttpGet httpGet = new HttpGet("http://service.zj.10086.cn/yw/bill/billDetailBefore.do?menuId=13003");
            try {
              HttpResponse loginResponse = httpClient.execute(httpGet);
              EntityUtils.toString(loginResponse.getEntity());
            } catch (ParseException e1) {
              e1.printStackTrace();
            } catch (ClientProtocolException e1) {
              e1.printStackTrace();
            } catch (IOException e1) {
              e1.printStackTrace();
            }
           String queryMouthUrl = "http://service.zj.10086.cn/yw/bill/billDetail.do?bid=&menuId=13003";
           String []mouthChinaArr = CallDetailDataUtils.fetchYearMouthForChinaMobile();
           String []mouth =  CallDetailDataUtils.fetchYearMouth();
           for(int index = 0;index < mouthChinaArr.length;index++){//遍历历史汇总详单信息并且入库
             
               boolean mouthRecordExist = true;
               String mouthStr = mouthChinaArr[index];
         
               detailUrlParam.add(new BasicNameValuePair("listtype", ""));
               detailUrlParam.add(new BasicNameValuePair("validateCode", ""));
               detailUrlParam.add(new BasicNameValuePair("month", mouthStr));
               try {
               //解析返回的数据
                String jsonData = HttpsClientUtil.HttpPost(httpClient,queryMouthUrl,detailUrlParam);
                logger.info("用户手机号码是{},查询到的数据是{}",phoneNo,jsonData);
              } catch (IOException e) {
                e.printStackTrace();
              }
           }
          }
        }).start();
        
        params = new ArrayList<NameValuePair>();
        params.add(new BasicNameValuePair("bid", "BC5CC0A69BC10482E044001635842132"));
        params.add(new BasicNameValuePair("validateCode", ""));
        //secondPassCheck二次校验码验证获取
        resultStr = HttpsClientUtil.HttpPost(httpClient,"http://service.zj.10086.cn/yw/detail/secondPassCheck.do", params);
       
        params = new ArrayList<NameValuePair>();
        params.add(new BasicNameValuePair("listtype", "1"));
        params.add(new BasicNameValuePair("month", "04-2015"));
        resultStr = HttpsClientUtil.HttpPost(httpClient,"http://service.zj.10086.cn/yw/detail/queryHisDetailBill.do?bid=&menuId=13009",params);
        req.getSession().setAttribute("httpClient", httpClient);
      } else {
        logger.error("提交的验证码或者服务密码有误，请重试,手机号码："+phoneNo+",服务密码:"+password+",验证码信息:"+validateCode);
      }
    } catch (IOException e) {
      logger.error("系统异常，请重试,手机号码："+phoneNo+",服务密码:"+password+",验证码信息:"+validateCode+"异常信息:"+e.toString());
    }
    
    req.getSession().setAttribute("httpClient", httpClient);
    req.getSession().setAttribute("phoneNo", phoneNo);
    
    logger.info("获取中国移动的二次校验动态码结束");
    resp.sendRedirect("/MobileCapture/chinaMobieSecondPassword.jsp");
  }
  
  
  @Override
  protected void doGet(HttpServletRequest req, HttpServletResponse resp)
      throws ServletException, IOException {
      this.doPost(req, resp);
  }

}
