package com.test.moible.chinaTelcom;

import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.net.URI;
import java.net.URISyntaxException;
import java.util.ArrayList;
import java.util.List;

import javax.net.ssl.SSLHandshakeException;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.http.HttpEntity;
import org.apache.http.HttpEntityEnclosingRequest;
import org.apache.http.HttpHost;
import org.apache.http.HttpRequest;
import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.NoHttpResponseException;
import org.apache.http.ProtocolException;
import org.apache.http.client.CircularRedirectException;
import org.apache.http.client.HttpRequestRetryHandler;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.params.ClientPNames;
import org.apache.http.client.utils.URIUtils;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.impl.client.DefaultRedirectHandler;
import org.apache.http.impl.client.DefaultRedirectHandler;
import org.apache.http.impl.client.RedirectLocations;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.params.CoreConnectionPNames;
import org.apache.http.params.CoreProtocolPNames;
import org.apache.http.params.HttpParams;
import org.apache.http.protocol.ExecutionContext;
import org.apache.http.protocol.HTTP;
import org.apache.http.protocol.HttpContext;
import org.apache.http.util.Args;
import org.apache.http.util.Asserts;
import org.apache.http.util.EntityUtils;
import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;
import org.jsoup.select.Elements;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.test.moible.utils.HttpsClientUtil;

/**
 * 获取电信的登录验证码信息
 * @author wudy
 *
 */
public class ChinaTelcomLoginImageServlet extends HttpServlet {
  
  private final Logger logger = LoggerFactory.getLogger(ChinaTelcomLoginImageServlet.class);

  /**
   * 
   */
  private static final long serialVersionUID = 1L;
  
  
  @Override
  protected void doPost(HttpServletRequest req, HttpServletResponse resp)
      throws ServletException, IOException {
    
    DefaultHttpClient httpClient = new DefaultHttpClient();

    logger.info("获取中国电信的验证码信息开始");
    PrintWriter printWriter = resp.getWriter();
    processTelocomHttpClient(httpClient);//处理电信重定向问题
    InputStream input = null;
    OutputStream out = null;
    try {
        //登录页面隐藏参数
        HttpsClientUtil.SecurityProcess(httpClient);
        String time = String.valueOf(System.currentTimeMillis());
        HttpGet httpGet = new HttpGet("http://189.cn/dqmh/Uam.do?method=loginUamSendJT&logintype=telephone&shopId=10012&loginRequestURLMark=http://189.cn/dqmh/frontLink.do?method=linkTo&shopId=10012&toStUrl=zjpr/cdr/getCdrDetailInput.htm&date="+time);
        HttpResponse response = httpClient.execute(httpGet);
        HttpEntity entity = response.getEntity();
        String resultStr = EntityUtils.toString(entity);
        Document doc = Jsoup.parse(resultStr);
        Element el0 = null;
        el0 = doc.getElementById("c2000004");
        Elements els = el0.getElementsByAttributeValue("type", "hidden");
        List<NameValuePair> nvps = new ArrayList<NameValuePair>();
        if(els!=null)
        {
            req.getSession().setAttribute("nvps", null);
        }
        //|| el.attr("name").equals("forbidpass")||el.attr("name").equals("forbidaccounts")
        for(Element el : els){
            if(el.attr("name").equals("areaname")||el.attr("name").equals("customFileld02")||el.attr("name").equals("authtype")){
                continue;
            }
            nvps.add(new BasicNameValuePair(el.attr("name"), el.val()));
            System.out.println(el.attr("name")+"==="+el.val());
        }
        req.getSession().setAttribute("nvps", nvps);
        
        HttpGet httpGet2 = new HttpGet("https://uam.ct10000.com/ct10000uam/validateImg.jsp?0.13705369044958116");
        HttpResponse response2 = httpClient.execute(httpGet2);
        HttpEntity entity2 = response2.getEntity();
        input = entity2.getContent();
        out = resp.getOutputStream();
        String fileName = System.currentTimeMillis() + ".png";
        out = new FileOutputStream(req.getSession().getServletContext().getRealPath("/upload") + "/" + fileName);
        int i;
        while((i = input.read()) != -1){
            out.write(i);
        }
        out.flush();
        printWriter.write("upload/" + fileName);
        req.getSession().setAttribute("httpClient", httpClient);
        logger.info("获取中国电信的验证码信息结束");
    } catch (Exception e) {
        logger.error("获取中国电信的登录验证码异常:" + e.toString());
    }finally{
      if(out!=null){
        try {
          input.close();
          out.close();//关闭输出流
        } catch (IOException e) {
         logger.error("获取中国电信的验证码，输出流关闭异常，异常信息:"+e.toString());
        }
      }
    }


    //resp.sendRedirect("/MobileCapture/chinaUnionLogin.jsp");
  }
  
  
  @Override
  protected void doGet(HttpServletRequest req, HttpServletResponse resp)
      throws ServletException, IOException {
      this.doPost(req, resp);
  }
  
  //处理电信重定向问题
  @SuppressWarnings("deprecation")
  private void processTelocomHttpClient(DefaultHttpClient httpClient)
  {
      httpClient.setRedirectHandler(new DefaultRedirectHandler() {

          private static final String REDIRECT_LOCATIONS = "http.protocol.redirect-locations";
          
          @Override  
          public boolean isRedirectRequested(HttpResponse response, HttpContext context) {  
              boolean isRedirect = super.isRedirectRequested(response, context);  
              if (!isRedirect) {  
                  int responseCode = response.getStatusLine().getStatusCode();  
                  if (responseCode == 301 || responseCode == 302) {  
                      return true;  
                  }  
              }  
              return isRedirect;  
          }
          
          @Override
          public URI getLocationURI(
                  final HttpResponse response,
                  final HttpContext context) throws ProtocolException {
              Args.notNull(response, "HTTP response");
              //get the location header to find out where to redirect to
              final org.apache.http.Header locationHeader = response.getFirstHeader("location");
              if (locationHeader == null) {
                  // got a redirect response, but no location header
                  throw new ProtocolException(
                          "Received redirect response " + response.getStatusLine()
                          + " but no location header");
              }
              final String location = locationHeader.getValue();
              if (logger.isDebugEnabled()) {
                logger.debug("Redirect requested to location '" + location + "'");
              }

              URI uri;
              try {
                  uri = new URI(location.replace(" ", ""));
              } catch (final URISyntaxException ex) {
                  throw new ProtocolException("Invalid redirect URI: " + location, ex);
              }

              final HttpParams params = response.getParams();
              // rfc2616 demands the location value be a complete URI
              // Location       = "Location" ":" absoluteURI
              if (!uri.isAbsolute()) {
                  if (params.isParameterTrue(ClientPNames.REJECT_RELATIVE_REDIRECT)) {
                      throw new ProtocolException("Relative redirect location '"
                              + uri + "' not allowed");
                  }
                  // Adjust location URI
                  final HttpHost target = (HttpHost) context.getAttribute(
                          ExecutionContext.HTTP_TARGET_HOST);
                  Asserts.notNull(target, "Target host");

                  final HttpRequest request = (HttpRequest) context.getAttribute(
                          ExecutionContext.HTTP_REQUEST);

                  try {
                      final URI requestURI = new URI(request.getRequestLine().getUri());
                      final URI absoluteRequestURI = URIUtils.rewriteURI(requestURI, target, true);
                      uri = URIUtils.resolve(absoluteRequestURI, uri);
                  } catch (final URISyntaxException ex) {
                      throw new ProtocolException(ex.getMessage(), ex);
                  }
              }

              if (params.isParameterFalse(ClientPNames.ALLOW_CIRCULAR_REDIRECTS)) {

                  RedirectLocations redirectLocations = (RedirectLocations) context.getAttribute(
                          REDIRECT_LOCATIONS);

                  if (redirectLocations == null) {
                      redirectLocations = new RedirectLocations();
                      context.setAttribute(REDIRECT_LOCATIONS, redirectLocations);
                  }

                  final URI redirectURI;
                  if (uri.getFragment() != null) {
                      try {
                          final HttpHost target = new HttpHost(
                                  uri.getHost(),
                                  uri.getPort(),
                                  uri.getScheme());
                          redirectURI = URIUtils.rewriteURI(uri, target, true);
                      } catch (final URISyntaxException ex) {
                          throw new ProtocolException(ex.getMessage(), ex);
                      }
                  } else {
                      redirectURI = uri;
                  }

                  if (redirectLocations.contains(redirectURI)) {
                      throw new CircularRedirectException("Circular redirect to '" +
                              redirectURI + "'");
                  } else {
                      redirectLocations.add(redirectURI);
                  }
              }

              return uri;
          }
      });
      httpClient.getParams().setParameter(CoreProtocolPNames.HTTP_CONTENT_CHARSET,  HTTP.UTF_8);  
      httpClient.getParams().setIntParameter(CoreConnectionPNames.CONNECTION_TIMEOUT,30000);  
      httpClient.getParams().setIntParameter(CoreConnectionPNames.SO_TIMEOUT,60000);
      httpClient.setHttpRequestRetryHandler(requestRetryHandler); 
  }
  
  /** 
   *  异常自动恢复处理 
   *  使用HttpRequestRetryHandler接口实现请求的异常恢复 
   */  
  private static HttpRequestRetryHandler requestRetryHandler = new HttpRequestRetryHandler() {  
      // 自定义的恢复策略  
      @SuppressWarnings("deprecation")
      public synchronized boolean retryRequest(IOException exception, int executionCount, HttpContext context) {  
          // 设置恢复策略，在发生异常时候将自动重试3次  
          if (executionCount > 3) {    
              // 超过最大次数则不需要重试    
              return false;    
          }    
          if (exception instanceof NoHttpResponseException) {    
              // 服务停掉则重新尝试连接    
              return true;    
          }    
          if (exception instanceof SSLHandshakeException) {    
              // SSL异常不需要重试    
              return false;    
          }   
          HttpRequest request = (HttpRequest) context.getAttribute(ExecutionContext.HTTP_REQUEST);  
          boolean idempotent = (request instanceof HttpEntityEnclosingRequest);  
          if (!idempotent) {  
              // 请求内容相同则重试  
              return true;  
          }  
          return false;  
      } 
  };

}
