package com.test.moible.chinaTelcom;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.http.NameValuePair;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.test.moible.utils.DateUtils;
import com.test.moible.utils.HttpsClientUtil;

/**
 * 获取电信的月详单查询页面
 * @author wudy
 *
 */
public class ChinaTelcomQueryDetailServlet extends HttpServlet {
  
  private final Logger logger = LoggerFactory.getLogger(ChinaTelcomQueryDetailServlet.class);

  /**
   * 
   */
  private static final long serialVersionUID = 1L;
  
  
  @Override
  protected void doPost(HttpServletRequest req, HttpServletResponse resp)
      throws ServletException, IOException {

    final DefaultHttpClient httpClient = (DefaultHttpClient) req.getSession().getAttribute("httpClient");
    
    try {

        final String validateCode = req.getParameter("validateCode");// 验证码
        final String phoneNo = req.getParameter("phoneNo");// 验证码
        new Thread(new Runnable() {//一个匿名类线程，用来抓取数据并且处理
          public void run() {
                  try {
                      String billurl = "http://zj.189.cn/zjpr/cdr/getCdrDetail.htm";
                      String monthStr=null; //月份参数yyyyMM
                      for(int i=0;i<6;i++) //获取最近6个月的话单信息
                      {
                          monthStr = DateUtils.getMonthBefore(i,"yyyyMM");
                          String resultStr = null;//请求实体对应的结果字符串
                          //查询通话详单
                          try {
                              List<NameValuePair> paramList = (List<NameValuePair>) new ArrayList<NameValuePair>();
                              paramList.add(new BasicNameValuePair("cdrCondition.areaid", "571"));
                              paramList.add(new BasicNameValuePair("cdrCondition.cdrlevel", "monthStr"));
                              paramList.add(new BasicNameValuePair("cdrCondition.cdrmonth",monthStr));
                              paramList.add(new BasicNameValuePair("cdrCondition.cdrtype","11"));
                              paramList.add(new BasicNameValuePair("cdrCondition.pagenum", "1"));
                              paramList.add(new BasicNameValuePair("cdrCondition.pagesize", "100000"));
                              paramList.add(new BasicNameValuePair("cdrCondition.product_servtype", "18"));
                              paramList.add(new BasicNameValuePair("cdrCondition.productid","71360688347"));
                              paramList.add(new BasicNameValuePair("cdrCondition.productnbr", phoneNo));
                              paramList.add(new BasicNameValuePair("cdrCondition.randpsw", validateCode)); //二次验证码
                              paramList.add(new BasicNameValuePair("cdrCondition.recievenbr", "移动电话")); 
                              // 中国电信获取具体的通信话单信息
                              resultStr = HttpsClientUtil.HttpPost(httpClient, billurl, paramList);// 请求返回的字符串
                             logger.info("查询 中国电信获取具体的通信话单信息{}",resultStr);
                       
                             Thread.sleep(3000);// 每次请求完成后停止3s,防止请求过度
                          } catch (InterruptedException e) {
                             logger.error("获取中国电信话单信息出错，信息如下："+e.toString());
                           }catch (IOException e) {
                             logger.error("获取中国电信话单信息出错，信息如下："+e.toString());
                           }
                          
                      }
                  } catch(Exception e){
                       e.printStackTrace();
                       logger.error("获取用户{}详单以及处理的的过程中出现异常，异常原因{}",e.toString());
                  }
          } 
         }).start();
    } catch (Exception e) {
        logger.error("请求出错:"+e.toString());
        req.getRequestDispatcher("/error.jsp").forward(req, resp);
    }
    req.getRequestDispatcher("/success.jsp").forward(req, resp);
  }
  
  
  @Override
  protected void doGet(HttpServletRequest req, HttpServletResponse resp)
      throws ServletException, IOException {
      this.doPost(req, resp);
  }

}
