package com.test.moible.chinaTelcom;

import java.io.IOException;
import java.util.List;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.ParseException;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.util.EntityUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.test.moible.utils.DateUtils;

/**
 * 获取电信二次验证码的同时获取月汇总账单
 * @author wudy
 *
 */
public class ChinaTelcomSecondPassCheckServlet extends HttpServlet {
  
  private final Logger logger = LoggerFactory.getLogger(ChinaTelcomSecondPassCheckServlet.class);

  /**
   * 
   */
  private static final long serialVersionUID = 1L;
  
  
  @Override
  protected void doPost(HttpServletRequest req, HttpServletResponse resp)
      throws ServletException, IOException {


    logger.info("中国电信的登录验证处理开始");
    String phoneNo = req.getParameter("phoneNo");
    String servicePasswd = req.getParameter("password");
    String validCode = req.getParameter("validateCode");

    final DefaultHttpClient httpClient = (DefaultHttpClient) req.getSession().getAttribute("httpClient");
    List<NameValuePair> nvps = (List<NameValuePair>) req.getSession().getAttribute("nvps");
    try {
        HttpGet httpGet = null;
        HttpResponse response = null;
        String str = null;
        nvps.add(new BasicNameValuePair("areaname", "浙江"));
        nvps.add(new BasicNameValuePair("authtype", "c2000004"));
        nvps.add(new BasicNameValuePair("customFileld01","3"));
        nvps.add(new BasicNameValuePair("customFileld02","12"));
        nvps.add(new BasicNameValuePair("username", phoneNo));
        nvps.add(new BasicNameValuePair("password", servicePasswd));
        nvps.add(new BasicNameValuePair("randomId", validCode));

        HttpPost httppost = new HttpPost("https://uam.ct10000.com/ct10000uam/login?service=http://www.189.cn/dqmh/Uam.do?method=loginJTUamGet&returnURL=1&register=register2.0&UserIp=115.236.190.202,%20223.202.80.20");
        httppost.setEntity(new UrlEncodedFormEntity(nvps));
        response = httpClient.execute(httppost);
        str = EntityUtils.toString(response.getEntity());
        
        String url = getUrlFromJscript(str); //ct
        httpGet = new HttpGet(url);
        response = httpClient.execute(httpGet);
        str = EntityUtils.toString(response.getEntity());
        
        httpGet = new HttpGet("http://189.cn/dqmh/frontLink.do?method=linkTo&shopId=10012&toStUrl=zjpr/cdr/getCdrDetailInput.htm"); //"http://zj.189.cn/zjpr/cdr/getCdrDetailInput.htm");
        response = httpClient.execute(httpGet);
        str = EntityUtils.toString(response.getEntity()); 
        
        url = getUrlFromJscript(str); // zj
        httpGet = new HttpGet(url);
        response = httpClient.execute(httpGet);
        str = EntityUtils.toString(response.getEntity());
        
        //下面可以正常请求电信抓取页面了
        new Thread(new Runnable(){//抓取中国电信的每月账单汇总信息
              public void run() {
                logger.info("开始获取用户的月度汇总账单细信息，手机号码：{}",phoneNo);              
               //开始获取月份话汇总消息
                   String urlPrxfix = "http://zj.189.cn/zjpr/bill/getBillDetail.htm?pr_billDomain.bill_month=";
                   String urlSuffix_package = "&pr_billDomain.product_id=11112319&pr_billDomain.query_type=1&pr_billDomain.bill_type=0&flag=htzd";//套餐
                   String urlSuffix_personal = "&pr_billDomain.product_id=1572814&pr_billDomain.query_type=1&pr_billDomain.bill_type=0&flag=htzd";//单个人使用
                   String monthTotalUrl = null;
                   String phoneType="1"; //手机套餐类型，默认1套餐  2个人
                   HttpGet httpGet = null;
                   HttpResponse response = null;
                   String data = null;
                   String tempMouth =null;
                   for(int j=1;j<=6;j++)
                   {
                    tempMouth = DateUtils.getMonthBefore(j,"yyyyMM");
                 
                    monthTotalUrl = urlPrxfix+tempMouth+urlSuffix_package;
                    httpGet = new HttpGet(monthTotalUrl);
                    try {
                        response = httpClient.execute(httpGet);
                        data = EntityUtils.toString(response.getEntity());
                 
                    } catch (ClientProtocolException e) {
                        logger.error("获取中国电信"+tempMouth+"汇总记录信息出错，信息如下："+e.toString());
                    } catch (ParseException e) {
                        logger.error("获取中国电信"+tempMouth+"汇总记录信息出错，信息如下："+e.toString());
                    } catch (IOException e) {
                        logger.error("获取中国电信"+tempMouth+"汇总记录信息出错，信息如下："+e.toString());
                    }
                
               }//for 循环结束
              }
            }).start();
        //发送二次验证码,供查询通话详单
        String data = "<buffalo-call><method>SendVCodeByNbr</method><string>"+phoneNo+"</string></buffalo-call>";
        HttpPost httpPost = new HttpPost("http://zj.189.cn/bfapp/buffalo/VCodeOperation");
        StringEntity entity = new StringEntity(data, "text/xml", "utf-8");
        httpPost.setEntity(entity);
        HttpResponse codeResponse = httpClient.execute(httpPost);
        str = EntityUtils.toString(codeResponse.getEntity());   
    } catch (ClientProtocolException e) {
         logger.error("系统异常，请重试,手机号码："+phoneNo+",服务密码:"+servicePasswd+",验证码信息:"+validCode+"异常信息:"+e.toString());
    } catch (IOException e) {
        e.printStackTrace();
    } 
    req.getSession().setAttribute("httpClient", httpClient);
  
    resp.sendRedirect("/MobileCapture/chinaMobieSecondPassword.jsp");
  }
  
  
  @Override
  protected void doGet(HttpServletRequest req, HttpServletResponse resp)
      throws ServletException, IOException {
      this.doPost(req, resp);
  }
  

  /**
   * 从js串中获取重定向地址
   * @return
   */
  private String getUrlFromJscript(String jscript)
  {
      if(jscript.indexOf("script")!=-1)
      {
          int beginIndex = jscript.indexOf("('")!=-1?jscript.indexOf("('"):0;
          int endIndex = jscript.indexOf("')")!=-1?jscript.indexOf("')"):0;
          String url = jscript.substring(beginIndex+2,endIndex);
          return url;
      }else{
          return jscript;
      }
  }


}
