package com.test.moible.chinaUnion;

import java.io.IOException;
import java.security.KeyManagementException;
import java.security.NoSuchAlgorithmException;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.util.EntityUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParser;
import com.test.moible.utils.CallDetailDataUtils;
import com.test.moible.utils.HttpsClientUtil;

/**
 * 获取联通登录处理页面，获取个人信息，月汇总账单和月语音详单信息
 * @author wudy
 *
 */
public class ChinaUnionLoginPageServlet extends HttpServlet {
  
  
  private final Logger logger = LoggerFactory.getLogger(ChinaUnionLoginPageServlet.class);

  /**
   * 
   */
  private static final long serialVersionUID = 1L;
  
  
  @Override
  protected void doPost(HttpServletRequest req, HttpServletResponse resp)
      throws ServletException, IOException {
    String   mobilePhone = req.getParameter("mobilePhone");
    String   password = req.getParameter("password");
    DefaultHttpClient httpClient = new DefaultHttpClient();//HttpClient对象
    // 中国联通登录处理过程
    String url =
        "https://uac.10010.com/portal/Service/MallLogin?callback=jQuery17202691898950318097_1403425938090&redirectURL=http%3A%2F%2Fwww.10010.com&userName="
            + mobilePhone
            + "&password="
            + password
            + "&pwdType=01&productType=01&redirectType=01&rememberMe=1";
    HttpGet httpGet = new HttpGet(url);
    HttpResponse loginResponse;

    try {
      HttpsClientUtil.SecurityProcess(httpClient);
    } catch (KeyManagementException e1) {
      e1.printStackTrace();
    } catch (NoSuchAlgorithmException e1) {
      e1.printStackTrace();
    }
    loginResponse = httpClient.execute(httpGet);
    if (loginResponse.getStatusLine().getStatusCode() == 200) {//登录验证成功才继续处理下去，否则就是输入信息有误返回失败
        HttpEntity loginEntity = loginResponse.getEntity();
        String loginEntityContent = EntityUtils.toString(loginEntity);
        if (loginEntityContent.contains("resultCode:\"0000\"")) { // 返回前台已经校验成功
              try {
                // 中国联通登录检查，确保是以及登录成功
                String checkUrl = "http://iservice.10010.com/e3/static/check/checklogin?_=1436239072215";
                HttpsClientUtil.HttpPost(httpClient, checkUrl, new ArrayList<NameValuePair>());
                String billurl = "http://iservice.10010.com/e3/static/query/callDetail?_=1436237387020&menuid=000100030001";
               

                logger.info("中国联通获取具体的通信话单信息");
                List<Map<String, String>> mapList = CallDetailDataUtils.fetchMouthArray();// 获取中国联通的每月的起始时间段
                for (Map<String, String> tempMap : mapList) {// 遍历最近的五个月的话单信息
                  StringBuilder strBuilder = new StringBuilder();
                  List<NameValuePair> params = new ArrayList<NameValuePair>();//通话详单的请求参数

                  params.add(new BasicNameValuePair("beginDate", tempMap.get("beginDate")));
                  params.add(new BasicNameValuePair("endDate", tempMap.get("endDate")));
                  params.add(new BasicNameValuePair("pageNo", "1"));
                  params.add(new BasicNameValuePair("pageSize", "2000"));

                  //中国联通获取具体的通信话单信息
                  String jsonData = HttpsClientUtil.HttpPost(httpClient, billurl, params);// 请求返回的字符串
                  JsonElement rootElement = new JsonParser().parse(jsonData);// 获取返回数据的
                                                                             // JsonElement对象
                  if (rootElement.isJsonObject()) {
                    JsonObject rootObject = rootElement.getAsJsonObject();// 获取返回数据的 JsonObject对象
                    JsonElement errorElement = rootObject.get("errorMessage");// 以下是对JSON串的详细解析信息
                    if (errorElement == null) {// 没有返回错误信息，说明该请求可以正常的返回结果
                      logger.info(tempMap.get("beginDate") + "到" + tempMap.get("endDate")
                      + "之间的查询结果如下，手机号码：" + jsonData);
                    } else {// 返回了错误信息，说明查询的对应记录不存在
                      logger.error(tempMap.get("beginDate") + "到" + tempMap.get("endDate")
                          + "之间的查询记录不存在，手机号码：" + mobilePhone);
                    }
                    Thread.sleep(4000);//连续请求的时间间隔
                  }
                }//通话详单获取结束
                
                
                //开始获取通话汇总消息
                logger.info("开始获取通话汇总消息");
                String  historyUrl = "http://iservice.10010.com/e3/static/query/queryHistoryBill?_="+new Date().getTime()+"&menuid=000100020001";
                String []mouthArr = CallDetailDataUtils.fetchYearMouthForChinaUnion();
                String []mouth =  CallDetailDataUtils.fetchYearMouth();
                for(int index = 0;index < mouthArr.length;index++){
                  List<NameValuePair> pairList = new ArrayList<NameValuePair>();
                  String tempMouth = mouthArr[index];
                  pairList.add(new BasicNameValuePair("querycode", "0001"));
                  pairList.add(new BasicNameValuePair("querytype", "0001"));
                  pairList.add(new BasicNameValuePair("billdate", tempMouth));
                  String jsonData = HttpsClientUtil.HttpPost(httpClient,historyUrl,pairList);
                  JsonElement rootElement = new JsonParser().parse(jsonData);
                  if(rootElement.isJsonObject()){
                    JsonObject rootObject = rootElement.getAsJsonObject();// 获取返回数据的 JsonObject对象
                    JsonElement errorElement = rootObject.get("errorMessage");// 以下是对JSON串的详细解析信息
                    if(errorElement==null){
                      logger.info("没有用户{}的当月{}的汇总话单信息",jsonData);
                    }else{
                      logger.error("没有用户{}的当月{}的汇总话单信息",mouthArr[index]);
                    }
                  }
                  System.out.println(jsonData);
                  Thread.sleep(2000);
                }
                //获取中国联通用户的个人信息
                logger.info("获取中国联通用户的个人信息");
                String userInfoUrl =
                    "http://iservice.10010.com/e3/static/query/searchPerInfo/?_="
                        + new Date().getTime() + "&menuid=000100030001";
                String infoData =
                    HttpsClientUtil.HttpPost(httpClient, userInfoUrl,
                        new ArrayList<NameValuePair>());// 请求返回的字符串
                JsonElement infoRootElement = new JsonParser().parse(infoData);
                if (infoRootElement.isJsonObject()) {

                  JsonObject infoRootObject = infoRootElement.getAsJsonObject();
                  JsonObject myDetailObject =  infoRootObject.get("result").getAsJsonObject().get("MyDetail").getAsJsonObject();
                  JsonObject userInfoObject = infoRootObject.get("userInfo").getAsJsonObject();
                  
                  logger.info("用户:"+mobilePhone+"infoRootObject信息:"+infoRootObject.toString());
                  logger.info("用户:"+mobilePhone+"Detail信息:"+myDetailObject.toString());
                  logger.info("用户:"+mobilePhone+"userInfo信息:"+userInfoObject.toString());
                }
              } catch (IOException e) {
                e.printStackTrace();
              }catch (InterruptedException e) {
                e.printStackTrace();
              }
        }
        req.getRequestDispatcher("/success.jsp").forward(req, resp);
      }else{
        req.getRequestDispatcher("/error.jsp").forward(req, resp);
      }
  }
  
  
  @Override
  protected void doGet(HttpServletRequest req, HttpServletResponse resp)
      throws ServletException, IOException {
      this.doPost(req, resp);
  }

}
